#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>

//
// Class for television programs
//
@interface Program : NSObject {
@private
  NSString* title;
  int       startTime;
  int       endTime;
  NSString* description;
  NSString* comment;
  NSString* address_epg;
  int       genre;
  int       g_code;
}

// initializers
-(Program*)init;
-(Program*)initWithCSVString : (NSString*)row;

// destructor
-(void)dealloc;

// time range
-(void)setTime : (int) start minutes: (int) duration;
-(int)getStartTime;
-(int)getEndTime;
-(int)getDuration;

// information setters
-(void)setTitle : (NSString*) title;
-(void)setDescription : (NSString*) description;
-(void)setComment : (NSString*) comment;
-(void)setGCode   : (int)code;
-(void)setEPGAddress: (NSString*)url;

// information getters
-(NSString*)getTitle;
-(NSString*)getDescription;
-(NSString*)getComment;
-(int)getGCode;
-(NSString*)getEPGAddress;

// genre
-(int)getGenre;
-(void)setGenre : (int)genre;
+(NSString*)getGenreName : (int)code;

// output
-(NSString*)description;
-(NSString*)toHTML : (NSString*)format;


@end

int _Program__comparator( id p1, id p2, void* context );
